function im_compr(image,frmt,compr)
%________________________________________________________
%
%  IM_COMPR
%________________________________________________________

%  1. Reads-in and presents as a mxn matrix X the data from file 
%     'image' written in graphical format 'frmt' (should be 
%     understood by Matlab's function imread).   
%  2. Uses Matlab's function svd to find the singular values
%     decomposition of this matrix, X=USV'.
%  3. Displays the image and plots a graph of the singular
%     values of X.
%  4. Computes, using U,S, and V, lower rank approximations X_1, X_2, ...
%     for X with the compression ratios compr(1), compr(2), ...  
%     respectively. Displays the corresponding images. 

%     Hint: To store an svd-based approximation X_i one should
%     need only compr(i)*m*n numbers instead of n*m numbers for X. 
%     Rank(X_i) is, therefore, about m*n*compr(i)/(m+n).
% Input arguments:
%    image - name of a file, a string; 
%    frmt  - format, a string;
%    compr - a one-dimensional array of compression ratios
%            satisfying 0 < compr(i) < 1
% Output arguments:
%        NONE
colormap(gray);
X=imread(image,frmt);
imagesc(X);
title('Compression=100%');
X=double(X);
[U,S,V]=svd(X);
figure(2)
plot(diag(S));
title('Compression=100%');
for i=1:size(compr,2)
    r=floor(compr(i)*size(S,2));
    S2=S(:,1:r);
    V2=V(:,1:r);
    figure(2*i+1);
    colormap(gray);
    imagesc(uint8(U*S2*V2'));
    title(['Compression=',num2str(compr(i)*100),'%']);
    figure(2*i+2);
    plot(diag(S2(:,1:r)));
    title(['Compression=',num2str(compr(i)*100),'%']);
end